package com.jtauber.fop.fo.pagination;

import com.jtauber.fop.fo.*;
import com.jtauber.fop.fo.properties.*;

import com.jtauber.fop.layout.Document;
import com.jtauber.fop.layout.PageMasterFactory;
import com.jtauber.fop.layout.SinglePageMasterFactory;
import com.jtauber.fop.layout.PageMaster;

import com.jtauber.fop.apps.FOPException;				   

public class SequenceSpecifierSingle extends SequenceSpecifier {

	public static class Maker extends FObj.Maker {
		public FObj make(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
			return new SequenceSpecifierSingle(doc, parent, propertyList);
		}
	}

	private SequenceSpecification sequenceSpecification;
	private LayoutMasterSet layoutMasterSet;
	private SinglePageMasterFactory pageMasterFactory;
	
	protected SequenceSpecifierSingle(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
		super(doc, parent, propertyList);
		this.foName =  "fo:sequence-specifer-single";
		
		if (parent.foName.equals("fo:sequence-specification")) {
			this.sequenceSpecification = (SequenceSpecification)parent;
			this.layoutMasterSet = this.sequenceSpecification.getLayoutMasterSet();
		} else {
			throw new FOPException("fo:sequence-specifier-single must be child of fo:sequence-specification, not "+parent.foName);
		}

		String pageMasterName = ((PageMasterName)this.properties.get("page-master-name")).string();
		try {
			this.pageMasterFactory = new SinglePageMasterFactory(this.layoutMasterSet.getLayoutMaster(pageMasterName).getPageMaster());
		} catch (java.lang.NullPointerException e) {
			throw new FOPException("page-master-name " + pageMasterName + " must be in layout-master-set");
		}
		this.sequenceSpecification.addSequenceSpecifier(this);
	}
	protected void addCharacters(char data[], int start, int length) {}
	protected void finishText() {}
	public PageMasterFactory getPageMasterFactory() {
		return this.pageMasterFactory;
	}
	public String getPageMasterName() {
		return ((PageMasterName)this.properties.get("page-master-name")).string();
	}
/**
 * This method was created in VisualAge.
 * @return FObjMaker
 */
public static FObj.Maker maker() {
	return new SequenceSpecifierSingle.Maker();
}
}