package com.jtauber.pdf;

import java.util.Vector;
import java.io.PrintWriter;

public class PDFPages extends PDFObject {
	private Vector kids;
	private int count = 0;
	private PDFPages parent;
	/**
	 * create a /Pages with the given number
	 */
	public PDFPages(int number) {
		super(number);
		this.kids = new Vector();
	}
	/**
	 * add given /Page object
	 */
	public void addPage(PDFPage page) {
		this.kids.addElement(page);
		page.setParent(this);
	}
	/**
	 * add given /Pages object
	 */
	public void addPages(PDFPages pages) {
		this.kids.addElement(pages);
		pages.setParent(this);
	}
public int getCount() {
	if (this.count == 0) {
		for (int i = 0; i < this.kids.size(); i++) {
			Object o = kids.elementAt(i);
			if (o instanceof PDFPage)
				this.count++;
			else
				this.count += ((PDFPages)o).getCount();
		}
	}
	return this.count;
}
public void setParent(PDFPages parent) {
	this.parent = parent;
}
public String toPDF() {
		String p = this.number + " " + this.generation + " obj\n";
		p += "<< /Type /Pages\n";
		p += "/Count " + this.getCount() + "\n";
		if (this.parent !=null) {
			p += "/Parent " + this.parent.referencePDF() + "\n";
		}
		p += "/Kids [ ";
		for (int i = 0; i < kids.size(); i++) {
			p += ((PDFObject)kids.elementAt(i)).referencePDF() + " ";
		}
		p += "] >>\n";
		p += "endobj\n";
		return p;
}
}